package com.jeeplus.finance.ccpm.controller;


import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.jeeplus.finance.ccpm.service.ccpm.FlowRequest;
import com.jeeplus.finance.ccpm.vo.*;
import com.jeeplus.finance.contractRegistration.domain.ContractFilePaper;
import com.jeeplus.finance.contractRegistration.domain.ContractInfo;
import com.jeeplus.finance.contractRegistration.mapper.ContractFilePaperMapper;
import com.jeeplus.finance.contractRegistration.mapper.ContractInfoMapper;
import com.jeeplus.finance.projectRecords.domain.CwProjectClientContact;
import com.jeeplus.finance.projectRecords.domain.CwProjectRecords;
import com.jeeplus.finance.projectRecords.mapper.CwProjectClientContactMapper;
import com.jeeplus.finance.projectRecords.mapper.CwProjectRecordsMapper;
import com.jeeplus.finance.projectReport.domain.*;
import com.jeeplus.finance.projectReport.mapper.*;
import com.jeeplus.finance.utils.RestTemplateService;

import com.jeeplus.finance.workClientInfo.domain.CwWorkClientBase;
import com.jeeplus.finance.workClientInfo.domain.CwWorkClientBilling;
import com.jeeplus.finance.workClientInfo.domain.CwWorkClientContact;
import com.jeeplus.finance.workClientInfo.domain.CwWorkClientType;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientBaseMapper;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientBillingMapper;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientContactMapper;
import com.jeeplus.finance.workClientInfo.mapper.CwWorkClientTypeMapper;
import com.jeeplus.sys.domain.Area;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import com.jeeplus.sys.feign.*;


import com.jeeplus.sys.service.dto.OfficeDTO;
import com.jeeplus.sys.service.dto.UserDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.lang.reflect.Type;
import java.util.*;

@Component
public class CcpmList  {
    @Autowired
    private FlowRequest flowRequest;

    @Autowired
    private RestTemplateService restTemplateService;

    @Autowired
    private CwProjectRecordsMapper cwProjectRecordsMapper;

    @Autowired
    private CwProjectReviewNewMapper cwProjectReviewNewMapper;

    @Autowired
    private CwProjectReportMapper cwProjectReportMapper;

    @Autowired
    private CwProjectInfoMapper cwProjectInfoMapper;

    @Autowired
    private CwProjectReportSignAndIssueMapper cwProjectReportSignAndIssueMapper;

    @Autowired
    private CwProjectReportOnlineArchivingMapper cwProjectReportOnlineArchivingMapper;

    @Autowired
    private CwProjectReportPaperArchivingMapper cwProjectReportPaperArchivingMapper;

    @Autowired
    private ContractInfoMapper contractInfoMapper;

    @Autowired
    private CwWorkClientBaseMapper cwWorkClientBaseMapper;

    @Autowired
    private CwWorkClientBillingMapper cwWorkClientBillingMapper;

    @Autowired
    private CwWorkClientTypeMapper cwWorkClientTypeMapper;

    @Autowired
    private ContractFilePaperMapper contractFilePaperMapper;

    @Resource
    private CwWorkClientContactMapper cwWorkClientContactMapper;

    @Resource
    private CwProjectClientContactMapper cwProjectClientContactMapper;





//    @PostConstruct
//    public void initMethod() throws Exception {
//        //获取所有的用户信息
//        List<UserDTO> allUserInfo = SpringUtil.getBean(IUserApi.class).getAllUserInfo();
//        getAllClient(allUserInfo);
//        getWorkContract(allUserInfo);
//        getProjectList(allUserInfo);
//    }

    public void getCcpmMethod() throws Exception {
        //获取所有的用户信息
        List<UserDTO> allUserInfo = SpringUtil.getBean(IUserApi.class).getAllUserInfo();
        getAllClient(allUserInfo);
        getWorkContract(allUserInfo);
        getProjectList(allUserInfo);
    }

    /*8
    获取项目信息
     */
    public void getProjectList( List<UserDTO> allUserInfo) throws Exception {
        //ccpm系统中的项目信息
        Object projectList = flowRequest.getProjectList();
        System.out.println(projectList);
        if(ObjectUtils.isNotEmpty(projectList)){
            List<RuralProjectRecordsVo> ruralProjectRecordsVos = JSONArray.parseArray(projectList.toString(), RuralProjectRecordsVo.class);
            //删除之前添加的数据
            cwProjectRecordsMapper.deleteByTenantId();
            cwProjectReviewNewMapper.deleteByTenantId();
            cwProjectReportMapper.deleteByTenantId();
            cwProjectInfoMapper.deleteByTenantId();
            cwProjectReportSignAndIssueMapper.deleteByTenantId();
            cwProjectReportOnlineArchivingMapper.deleteByTenantId();
            cwProjectReportPaperArchivingMapper.deleteByTenantId();
            cwProjectClientContactMapper.deleteByTenantId();
            //将获取到的项目信息通过遍历的方式插入到数据表中
            if (CollectionUtils.isNotEmpty(ruralProjectRecordsVos)){
                for (RuralProjectRecordsVo recordsVo : ruralProjectRecordsVos) {
                    //项目
                    CwProjectRecords cwProjectRecords = new CwProjectRecords();
                    //复核
                    CwProjectReviewNew cwProjectReviewNew = new CwProjectReviewNew();
                    //报告
                    CwProjectReport report = new CwProjectReport();
                    CwProjectInfoData cwProjectInfoData = new CwProjectInfoData();
                    //报告签发
                    CwProjectReportSignAndIssue cwProjectReportSignAndIssue = new CwProjectReportSignAndIssue();
                    //电子归档
                    CwProjectReportOnlineArchiving cwProjectReportOnlineArchiving = new CwProjectReportOnlineArchiving();
                    //纸质归档
                    CwProjectReportPaperArchiving cwProjectReportPaperArchiving = new CwProjectReportPaperArchiving();

                    //项目
                    if (StringUtils.isNotBlank(recordsVo.getId())){
                        cwProjectRecords.setId(recordsVo.getId());//项目id
                        cwProjectRecords.setProjectNumber(recordsVo.getProjectId());//项目编号
                        cwProjectRecords.setContractId(recordsVo.getWorkContractInfo().getId());
                        cwProjectRecords.setProjectName(recordsVo.getProjectName());
                        if (StringUtils.isNotBlank(recordsVo.getProjectType())){
                            if (recordsVo.getProjectType().equals("2")){
                                cwProjectRecords.setProjectType("1");//造价
                                cwProjectRecords.setReportType(recordsVo.getAttachmentProjectSort()); //项目类别
                            }else {
                                cwProjectRecords.setProjectType("2");
                                cwProjectRecords.setReportType(recordsVo.getAttachmentProjectSort());
                            }
                        }
                        cwProjectRecords.setStatus(recordsVo.getProjectStatus()+"");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()) {
                                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getById(matchingUserId.get());
                                if (userDTO != null) {
                                    cwProjectRecords.setCreateById(userDTO.getId());
                                    cwProjectRecords.setUpdateById(userDTO.getId());
                                    cwProjectRecords.setOfficeId(userDTO.getOfficeDTO().getId());
                                }
                            }

                        }
                        cwProjectRecords.setCreateTime(recordsVo.getCreateDate());
                        cwProjectRecords.setTenantId("ccpm");
                        //获取项目所在地
                        List<Area> areaDTO = SpringUtil.getBean(IAreaApi.class).getAreaDTOByName(recordsVo.getArea().getName());
                        if (areaDTO.size()>1){
                            //当出现两个相同的最后一级区域的时候去查询他们的上一级区域,然后根据上一级id进行添加
                            List<Area> parentArea = SpringUtil.getBean(IAreaApi.class).getAreaDTOByName(recordsVo.getCity());
                            for (Area area : areaDTO) {
                                for (Area parArea : parentArea) {
                                    if (area.getParentId().equals(parArea.getId())){
                                        cwProjectRecords.setAreaId(area.getId());
                                    }

                                }
                            }
                        }else {
                            if (ObjectUtils.isNotEmpty(areaDTO)){
                                for (Area area : areaDTO) {
                                    cwProjectRecords.setAreaId(area.getId());

                                }
                            }
                        }
                        //项目等级
                        if (StringUtils.isNotBlank(recordsVo.getSubmitMoney())){
                            if (recordsVo.getSubmitMoney().equals("1")){
                                cwProjectRecords.setProjectLevel("2");
                            }else {
                                cwProjectRecords.setProjectLevel("1");
                            }
                        }

                        //项目金额
                        if (ObjectUtils.isNotEmpty(recordsVo.getTotalFees())){
                            cwProjectRecords.setProjectMoney(recordsVo.getTotalFees().toString());
                        }

                        //项目开始时间结束时间
                        cwProjectRecords.setProjectStartTime(recordsVo.getStartDate());
                        cwProjectRecords.setProjectEndTime(recordsVo.getEndDate());
                        //工程类型
                        cwProjectRecords.setEngineeringType(recordsVo.getEngineeringType());
                        //项目负责人
                        if (StringUtils.isNotBlank(recordsVo.getProjectMasterPhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getProjectMasterPhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getById(matchingUserId.get());
                                if (userDTO != null){
                                    cwProjectRecords.setProjectLeaderId(userDTO.getId());
                                }
                            }

                        }
                        cwProjectRecordsMapper.insert(cwProjectRecords);
                        //项目联系人
                        if (CollectionUtils.isNotEmpty(recordsVo.getWorkClientLinkmanList())){
                            for (WorkClientLinkman workClientLinkman : recordsVo.getWorkClientLinkmanList()) {
                                if (workClientLinkman.getClientId() != null){
                                    CwProjectClientContact cwProjectClientContact = new CwProjectClientContact();
                                    cwProjectClientContact.setProjectId(recordsVo.getId());
                                    cwProjectClientContact.setClientId(workClientLinkman.getId());
                                    cwProjectClientContact.setEmail(workClientLinkman.getEmail());
                                    cwProjectClientContact.setContactFirst(workClientLinkman.getLinkMobile());
                                    cwProjectClientContact.setContactSecond(workClientLinkman.getLinkPhone());
                                    cwProjectClientContact.setName(workClientLinkman.getName());
                                    cwProjectClientContact.setPosition(workClientLinkman.getPosition());
                                    if (StringUtils.isNotBlank(workClientLinkman.getOffice())){
                                        OfficeDTO officeDTOByName = SpringUtil.getBean(IOfficeApi.class).getOfficeDTOByName(workClientLinkman.getOffice());
                                        if (officeDTOByName != null){
                                            cwProjectClientContact.setOfficeId(officeDTOByName.getId());
                                        }
                                    }
                                    cwProjectClientContact.setClientContactId(workClientLinkman.getClientId().getId());
                                    cwProjectClientContact.setTenantId("ccpm");
                                    cwProjectClientContactMapper.insert(cwProjectClientContact);
                                }
                            }
                        }
                    }
                    //质量复核
                    if (StringUtils.isNotBlank(recordsVo.getPrdId())){
                        //复核信息
                        cwProjectReviewNew.setId(recordsVo.getPrdId());
                        cwProjectReviewNew.setProjectId(recordsVo.getId());
                        cwProjectReviewNew.setReviewStatus(recordsVo.getProjectReportStatus().toString());
                        cwProjectReviewNew.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectReviewNew.setCreateById(matchingUserId.get());
                                cwProjectReviewNew.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectReviewNew.setCreateTime(recordsVo.getCreateDate());
                        cwProjectReviewNewMapper.insert(cwProjectReviewNew);
                    }
                    //报告
                    if (StringUtils.isNotBlank(recordsVo.getPrdId())){
                        String id = UUID.randomUUID().toString().replace("-", "");
                        //报告信息
                        report.setId(id);
                        report.setProjectId(recordsVo.getId());
                        report.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                report.setCreateById(matchingUserId.get());
                                report.setUpdateById(matchingUserId.get());
                            }

                        }
                        report.setCreateTime(recordsVo.getCreateDate());
                        cwProjectReportMapper.insert(report);

                        //报告编号
                        String id1 = UUID.randomUUID().toString().replace("-", "");
                        cwProjectInfoData.setId(id1);
                        cwProjectInfoData.setReportId(id);
                        cwProjectInfoData.setReportNo(recordsVo.getProjectReportNumber());
                        cwProjectInfoData.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectInfoData.setCreateById(matchingUserId.get());
                                cwProjectInfoData.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectInfoData.setCreateTime(recordsVo.getCreateTime());
                        cwProjectInfoMapper.insert(cwProjectInfoData);
                    }
                    //报告签发
                    if (StringUtils.isNotBlank(recordsVo.getPrdtId())){
                        cwProjectReportSignAndIssue.setId(recordsVo.getPrdtId());
                        cwProjectReportSignAndIssue.setProjectId(recordsVo.getId());
                        if (ObjectUtils.isNotEmpty(recordsVo.getProjectReportStatusTwo())){
                            cwProjectReportSignAndIssue.setStatus(recordsVo.getProjectReportStatusTwo().toString());
                        }else {
                            cwProjectReportSignAndIssue.setStatus("");

                        }
                        cwProjectReportSignAndIssue.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectReportSignAndIssue.setCreateById(matchingUserId.get());
                                cwProjectReportSignAndIssue.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectReportSignAndIssue.setCreateTime(recordsVo.getCreateDate());
                        cwProjectReportSignAndIssueMapper.insert(cwProjectReportSignAndIssue);
                    }

                    //电子归档
                    if (StringUtils.isNotBlank(recordsVo.getPrrId())){
                        cwProjectReportOnlineArchiving.setId(recordsVo.getPrrId());
                        cwProjectReportOnlineArchiving.setReportId(report.getId());
                        if (ObjectUtils.isNotEmpty(recordsVo.getProjectReportRecordStatus())){
                            cwProjectReportOnlineArchiving.setStatus(recordsVo.getProjectReportRecordStatus().toString());
                        }else {
                            cwProjectReportOnlineArchiving.setStatus("");
                        }
                        cwProjectReportOnlineArchiving.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectReportOnlineArchiving.setCreateById(matchingUserId.get());
                                cwProjectReportOnlineArchiving.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectReportOnlineArchiving.setCreateTime(recordsVo.getCreateDate());
                        cwProjectReportOnlineArchivingMapper.insert(cwProjectReportOnlineArchiving);
                    }
                    //纸质归档
                    if (StringUtils.isNotBlank(recordsVo.getPrrdId())){
                        //纸质归档
                        cwProjectReportPaperArchiving.setId(recordsVo.getPrrdId());
                        cwProjectReportPaperArchiving.setReportId(report.getId());
                        if (ObjectUtils.isNotEmpty(recordsVo.getDownProjectReportRecordStatus())){
                            cwProjectReportPaperArchiving.setStatus(recordsVo.getDownProjectReportRecordStatus().toString());
                        }else{
                            cwProjectReportPaperArchiving.setStatus("");
                        }
                        cwProjectReportPaperArchiving.setTenantId("ccpm");
                        if (StringUtils.isNotBlank(recordsVo.getCreateNamePhone())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(recordsVo.getCreateNamePhone()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                cwProjectReportPaperArchiving.setCreateById(matchingUserId.get());
                                cwProjectReportPaperArchiving.setUpdateById(matchingUserId.get());
                            }

                        }
                        cwProjectReportPaperArchiving.setCreateTime(recordsVo.getCreateDate());
                        cwProjectReportPaperArchivingMapper.insert(cwProjectReportPaperArchiving);
                    }
                }
            }
        }


    }


    /**
     * 获取合同信息
     */
    public void getWorkContract( List<UserDTO> allUserInfo){
        //ccpm系统中的合同信息
        Object contractList = flowRequest.getWorkContractList();
        System.out.println(contractList);
        if (ObjectUtils.isNotEmpty(contractList)){
            List<WorkContractInfoVo> workContractInfoVos = JSONArray.parseArray(contractList.toString(), WorkContractInfoVo.class);
            //删除之前添加的合同数据
            contractInfoMapper.deleteByTenantId();
            contractFilePaperMapper.deleteByTenantId();
            //新增数据
            if (CollectionUtils.isNotEmpty(workContractInfoVos)){
                for (WorkContractInfoVo contractInfoVo : workContractInfoVos) {
                    ContractInfo workContractInfo = new ContractInfo();
                    workContractInfo.setId(contractInfoVo.getId());//id
                    if (StringUtils.isNotBlank(contractInfoVo.getCreateUserMobile())){
                        Optional<String> matchingUserId = allUserInfo.stream()
                                .filter(user -> user.getMobile().equals(contractInfoVo.getCreateUserMobile()))
                                .map(UserDTO::getId)
                                .findFirst();
                        if (matchingUserId.isPresent()){
                            workContractInfo.setCreateById(matchingUserId.get());
                            workContractInfo.setUpdateById(matchingUserId.get());
                        }
                    }
                    workContractInfo.setCreateTime(contractInfoVo.getCreateDate());
                    workContractInfo.setContractName(contractInfoVo.getName());//合同名称
                    workContractInfo.setContractNo(contractInfoVo.getContractNum());//合同编号
                    workContractInfo.setClientContacts(contractInfoVo.getClient().getId());//客户id
                    workContractInfo.setStatus(contractInfoVo.getContractState());//合同状态
                    //合同金额
                    if (StringUtils.isNotBlank(contractInfoVo.getContractPrice())){
                        double newPrice = Double.parseDouble(contractInfoVo.getContractPrice());
                        workContractInfo.setContractAmount(newPrice);
                        workContractInfo.setActualContractAmount(newPrice);
                    }

                    workContractInfo.setTenantId("ccpm");
                    //合同金额类别
                    if (StringUtils.isNotBlank(contractInfoVo.getContractInformation())){
                        if ("0".equals(contractInfoVo.getContractInformation())){
                            workContractInfo.setContractAmountType("1");//金额合同
                        }else if ("1".equals(contractInfoVo.getContractInformation())){
                            workContractInfo.setContractAmountType("2");//费率合同
                        }
                    }
                    //收费标准
                    if (StringUtils.isNotBlank(contractInfoVo.getChargeCriterion())){
                        String dictValue = SpringUtil.getBean(IDictApi.class).getDictValue(contractInfoVo.getChargeCriterion(), "contract_fee_new", "");
                        workContractInfo.setFees(dictValue);
                    }
                    if (StringUtils.isNotBlank(contractInfoVo.getOtherDetails())){
                        workContractInfo.setContractFee(contractInfoVo.getOtherDetails());
                    }
                    //对方合同编号
                    workContractInfo.setContractOpposite(contractInfoVo.getContractOpposite());
                    contractInfoMapper.insert(workContractInfo);
                    //保存合同归档信息
                    ContractFilePaper workContractFile = new ContractFilePaper();
                    workContractFile.setContractInfoId(contractInfoVo.getId());
                    workContractInfo.setFiledNo(contractInfoVo.getRecordNum());//案卷号
                    workContractFile.setFiledPaperType(contractInfoVo.getContrractRecordStatus());
                    workContractFile.setTenantId("ccpm");
                    workContractFile.setCreateTime(contractInfoVo.getCreateDate());
                    if (StringUtils.isNotBlank(contractInfoVo.getCreateUserMobile())){
                        Optional<String> matchingUserId = allUserInfo.stream()
                                .filter(user -> user.getMobile().equals(contractInfoVo.getCreateUserMobile()))
                                .map(UserDTO::getId)
                                .findFirst();
                        if (matchingUserId.isPresent()){
                            workContractFile.setCreateById(matchingUserId.get());
                            workContractFile.setUpdateById(matchingUserId.get());
                        }
                    }
                    contractFilePaperMapper.insert(workContractFile);
                    if (contractInfoVo.getWorkAttachments()!=null){
                        SpringUtil.getBean ( IWorkAttachmentApi.class ).deleteByAttachmentId(contractInfoVo.getId());
                        UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(contractInfoVo.getCreateUser());
                        if (userDTO != null){
                            saveWorkContractFiles(contractInfoVo.getWorkAttachments(),userDTO,contractInfoVo.getId(),"workcontract");

                        }
                    }
                }
            }
        }

    }

    /**
     * 保存附件信息
     * @param list 待保存的附件列表
     * @param userDTO 当前登录用户
     * @param id 关联id
     */
    @Transactional(rollbackFor = Exception.class)
    public void saveWorkContractFiles(List<WorkClientAttachment> list, UserDTO userDTO, String id,String flag) {
        int j = 1;
        for (WorkClientAttachment dto : list) {
            WorkAttachmentInfo i = new WorkAttachmentInfo();
            //包含了url、size、name
            i.setId(UUID.randomUUID().toString().replace("-", ""));
//            i.getCreateBy().setId(userDTO.getId());
            i.setCreateTime(new Date());
//            i.getUpdateBy().setId(userDTO.getId());
            i.setUpdateTime(new Date());
            i.setDelFlag(0);
            i.setUrl(dto.getUrl());
            //文件类型处理
            List<String> strings = Arrays.asList(dto.getAttachmentName().split("\\."));
            if (CollectionUtil.isNotEmpty(strings)) {
                i.setType(strings.get(1));
            }
            i.setAttachmentId(id);
            i.setAttachmentName(dto.getAttachmentName());
            i.setAttachmentFlag(flag);
            i.setFileSize(dto.getFileSize());
            i.setSort(j);
            Map<String,String> map = new HashMap<>();
            String workAttachment = JSON.toJSONString((i));
            String userDTOInfo = JSON.toJSONString((userDTO));
            map.put("workAttachment",workAttachment);
            map.put("userDTO",userDTOInfo);
            SpringUtil.getBean ( IWorkAttachmentApi.class ).insertWorkAttachment(map);
            j++;
        }
    }


    //获取ccpm中所有的客户信息
    public void getAllClient( List<UserDTO> allUserInfo){

        Object clientList = flowRequest.getClientList();
        System.out.println(clientList);
        if (ObjectUtils.isNotEmpty(clientList)){
            List<WorkClientInfoVo> workClientInfoVos = JSONArray.parseArray(clientList.toString(), WorkClientInfoVo.class);
            //删除本系统中所有之前新增的ccpm系统中的数据
            cwWorkClientBaseMapper.deleteByTenantId();
            cwWorkClientBillingMapper.deleteByTenantId();
            cwWorkClientTypeMapper.deleteByTenantId();
            cwWorkClientBaseMapper.deleteLinkmanByTenantId();
            for (WorkClientInfoVo workClientInfoVo : workClientInfoVos) {
                //客户基本信息
                CwWorkClientBase cwWorkClientBase = new CwWorkClientBase();
                cwWorkClientBase.setId(workClientInfoVo.getId());
                if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                    Optional<String> matchingUserId = allUserInfo.stream()
                            .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                            .map(UserDTO::getId)
                            .findFirst();
                    if (matchingUserId.isPresent()){
                        cwWorkClientBase.setCreateById(matchingUserId.get());
                        cwWorkClientBase.setUpdateById(matchingUserId.get());
                    }

                }
                cwWorkClientBase.setName(workClientInfoVo.getName());//客户名称
                cwWorkClientBase.setIsUscCode(workClientInfoVo.getHasUscc()+"");//是否有统一社会信用代码
                cwWorkClientBase.setUscCode(workClientInfoVo.getUscCode());//统一社会信用代码
                cwWorkClientBase.setAddress(workClientInfoVo.getRegisterAddress());//地址
                cwWorkClientBase.setMobile(workClientInfoVo.getTelephone()); //电话
                if (StringUtils.isNotBlank(workClientInfoVo.getCompanyIndustry())){
                    String dictValue = SpringUtil.getBean(IDictApi.class).getDictValue(workClientInfoVo.getCompanyIndustry(), "cw_work_client_industry", "");
                    cwWorkClientBase.setIndustry(dictValue); //所属行业
                }

                cwWorkClientBase.setStatus("5");
                cwWorkClientBase.setTenantId("ccpm");
                cwWorkClientBase.setCreateTime(workClientInfoVo.getCreateDate());
                cwWorkClientBaseMapper.insert(cwWorkClientBase);
                //修改客户开户行信息
                if (CollectionUtils.isNotEmpty(workClientInfoVo.getWorkClientBankList())){
                    for (WorkClientBankVo workClientBank : workClientInfoVo.getWorkClientBankList()) {
                        CwWorkClientBilling clientBilling = new CwWorkClientBilling();
                        clientBilling.setId(workClientBank.getId());
                        clientBilling.setClientId(workClientBank.getClientId().getId());
                        clientBilling.setAccountHolder(workClientBank.getOurBank());//开户行
                        clientBilling.setAccount(workClientBank.getBankNumber());//银行账号
                        if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                            Optional<String> matchingUserId = allUserInfo.stream()
                                    .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                                    .map(UserDTO::getId)
                                    .findFirst();
                            if (matchingUserId.isPresent()){
                                clientBilling.setCreateById(matchingUserId.get());
                                clientBilling.setUpdateById(matchingUserId.get());
                            }

                        }
                        clientBilling.setCreateTime(workClientInfoVo.getCreateDate());
                        clientBilling.setTenantId("ccpm");
                        cwWorkClientBillingMapper.insert(clientBilling);

                    }
                }
                //修改客户类型信息
                CwWorkClientType cwWorkClientType = new CwWorkClientType();
                cwWorkClientType.setIsListed("0");
                cwWorkClientType.setTenantId("ccpm");
                cwWorkClientType.setClientId(workClientInfoVo.getId());
                cwWorkClientType.setCreateTime(workClientInfoVo.getCreateDate());
                if (StringUtils.isNotBlank(workClientInfoVo.getCreateMobile())){
                    Optional<String> matchingUserId = allUserInfo.stream()
                            .filter(user -> user.getMobile().equals(workClientInfoVo.getCreateMobile()))
                            .map(UserDTO::getId)
                            .findFirst();
                    if (matchingUserId.isPresent()){
                        cwWorkClientType.setCreateById(matchingUserId.get());
                        cwWorkClientType.setUpdateById(matchingUserId.get());
                    }
                }
                cwWorkClientTypeMapper.insert(cwWorkClientType);

                //客户联系人
                CwWorkClientContact cwWorkClientContact = new CwWorkClientContact();
                if (workClientInfoVo.getWorkClientLinkmanList() != null){
                    for (WorkClientLinkman clientLinkman : workClientInfoVo.getWorkClientLinkmanList()) {
                        cwWorkClientContact.setId(clientLinkman.getId());
                        cwWorkClientContact.setTenantId("ccpm");
                        cwWorkClientContact.setClientId(workClientInfoVo.getId());
                        cwWorkClientContact.setEmail(clientLinkman.getEmail());
                        cwWorkClientContact.setContactFirst(clientLinkman.getLinkMobile());
                        cwWorkClientContact.setContactSecond(clientLinkman.getLinkPhone());
                        if (StringUtils.isNotBlank(clientLinkman.getOffice())){
                            OfficeDTO officeDTOByName = SpringUtil.getBean(IOfficeApi.class).getOfficeDTOByName(clientLinkman.getOffice());
                            if (officeDTOByName != null){
                                cwWorkClientContact.setOfficeId(officeDTOByName.getId());
                            }
                        }
                        cwWorkClientContact.setName(clientLinkman.getName());
                        cwWorkClientContact.setPosition(clientLinkman.getPosition());
                        cwWorkClientContactMapper.insert(cwWorkClientContact);
                    }
                }

                if (workClientInfoVo.getWorkAttachments()!=null){
                    SpringUtil.getBean ( IWorkAttachmentApi.class ).deleteByAttachmentId(workClientInfoVo.getId());
                    UserDTO userDTO = SpringUtil.getBean(IUserApi.class).getByLoginNameNotTenantId(workClientInfoVo.getUserName());
                    if (userDTO != null){
                        saveWorkContractFiles(workClientInfoVo.getWorkAttachments(),userDTO,workClientInfoVo.getId(),"cw_work_client");
                    }
                }



            }
        }



    }

}
